#include <SoftwareSerial.h> 

#define pin_TX       7         // artuinio TX mp3 player RX
#define pin_RX       8         // artuinio RX mp3 player TX

SoftwareSerial mp3(pin_RX, pin_TX); // RX, TX


//задержки в произнощении часов.
 uint16_t clock_delay[25]={1056,1200,1176,1080,1320,1152,1296,1200,1248,1368,1488,1488,1632,1560,1584,1440,1560,1584,1656,1680,1416,1752,1656,1656,1056};
//буффер команд
 uint8_t cmdbuf[8] = {0x7E, 0xFF, 06, 00, 00, 00, 00, 0xEF};
 uint8_t ansbuf[10] = {0};
//Количество файлов в папках 01 - 99
 uint16_t count_files_folder[max_mp3_forders+1] = {0};
//Что играет, и что надо играть
 uint8_t real_voice=20;
// uint8_t set_voice=20;
 uint8_t way_voice = 30;

 uint16_t play_folder=0;
 uint16_t play_files_folder = 0;
 uint16_t set_play_folder=0;
 uint16_t set_play_files_folder = 0;
 bool Playflag = true;
//-------------------------------
void byte2hex(uint8_t b)
{
#ifdef _DEBUG
Serial.print("0x");
  if (b < 16) Serial.print("0");
Serial.print(b, HEX);
Serial.print(" ");
#endif
}

void command(int8_t cmd, int8_t dat5, int8_t dat6)
{
//  cmdbuf[0] = 0x7e; 
//  cmdbuf[1] = 0xFF; 
//  cmdbuf[2] = 0x06; 
  cmdbuf[3] = cmd;  // polecenie
  cmdbuf[4] = 0x00; // 0x00 = no feedback, 0x01 = feedback
  cmdbuf[5] = dat5; // parametr DAT1
  cmdbuf[6] = dat6; // parametr DAT2
//  cmdbuf[7] = 0xef; 
#ifdef _DEBUG
  Serial.print("cmd:");
#endif
  for (uint8_t i = 0; i < 8; i++)
  {
    mp3.write(cmdbuf[i]);
    delay(5);
    byte2hex(cmdbuf[i]);
  }
#ifdef _DEBUG
  Serial.println();
#endif
}
//------------------------------- 
boolean answer(void)
{
  uint8_t i;
  uint8_t b = 0;
#ifdef _DEBUG
  Serial.print("asn:");
#endif
ansbuf[5]=0;
ansbuf[6]=0;
  while(mp3.available() && (b!=0x7E))
  {
    b = mp3.read();
    delay(6);
  }
  ansbuf[0] = b;
  byte2hex(b);
  i = 1;
  while(mp3.available() && (i < 10))
  {
    b = mp3.read();
    ansbuf[i] = b;
    i++;
    byte2hex(b);
    delay(6);
  }
#ifdef _DEBUG
  Serial.println();
#endif

  if ((ansbuf[0] == 0x7E) && (ansbuf[9] == 0xEF))
  {
    return true;
  }
 
  return false;
}
//-------------------------------
byte play_status()
{
 int pl=255; 
 answer();
 command(0x42, 0, 2);
 uint32_t timer_1=millis();
 while ((not mp3.available()) && (millis()-timer_1<1000)) delay(5);
  if (answer())
   {
   if (ansbuf[3] == 0x42)  pl=ansbuf[6];
   if (ansbuf[3] == 0x3D)  pl=0;
   }
    #ifdef _DEBUG
      Serial.println("Play status: "+String(pl));
    #endif
   
  return pl; 
}
//-------------------------------
void playFolder(int8_t p_path,int8_t p_file)
{
//  answer();
  command(0x0f, p_path,p_file); 
    #ifdef _DEBUG
      Serial.println("Play:"+String(p_path)+"_"+String(p_file));
    #endif
}
void playFolderbig(int8_t p_path,int16_t p_file)
{
//  answer();
  int16_t Para_MSB=p_path*16 + p_file/256;
  int16_t Para_LSB=p_file;
  command(0x14, Para_MSB,Para_LSB); 
    #ifdef _DEBUG
      Serial.println("Play:"+String(p_path)+"_"+String(p_file));
      Serial.println("Para_MSB:"+String(Para_MSB)+", Para_LSB:"+String(Para_LSB));
    #endif
}
//-------------------------------
void play_time_ADVERT(int8_t pt_h, int8_t pt_m)
{
 if (pt_h==0) pt_h=24;
  if (mp3_play_time==1 || mp3_play_time==3) 
    {
      command(0x13, 0, pt_h); 
      mp3_play_time=(mp3_play_time=1)?2:0;
    #ifdef _DEBUG
      Serial.println("Play H: "+String(pt_h));
    #endif
      mp3_time_timer=millis();
    } else 
  if (mp3_play_time==2) 
   {
    if (millis()-mp3_time_timer>clock_delay[pt_h]+150)
    {
      command(0x13, 0, pt_m+100); 
      mp3_play_time=5;
      mp3_time_timer=millis();
    #ifdef _DEBUG
      Serial.println("Play M: "+String(pt_m));
    #endif
    }
   } else  
  if (mp3_play_time==5) 
   { 
     if (millis()-mp3_time_timer>3000) mp3_play_time=0;

   } 
}
//-------------------------------
void mp3_next(int8_t sets)
{
  
  if (set_play_folder>0)
  { 
    if (play_folder!=set_play_folder || play_status()==0 || sets>0)
   {
     play_folder=set_play_folder;
     set_play_files_folder=random(count_files_folder[play_folder])+1;
     play_files_folder=set_play_files_folder;
     playFolderbig(play_folder,play_files_folder);
   }
  } else { play_files_folder=0; play_folder=0;}
  
}

//-------------------------------
void mp3_stop(int8_t sets)
{
    set_play_files_folder=0;
    play_files_folder=0;
    if (sets>0) command(0x16,0,0); 
}

//-------------------------------
uint8_t i_mp3;
void  draw_count_mp3(void)
{
    u8g.setFont(u8g_font_gdr9n);
    u8g.setPrintPos(1, 16);    
    u8g.print(i_mp3);
    u8g.setPrintPos(1, 30);
    u8g.print(count_files_folder[i_mp3]);
}


void mp3_read_max_file()
{
  for (i_mp3=1;i_mp3<=max_mp3_forders;i_mp3++) {
    command(0x4E, 0, i_mp3);
    while (not mp3.available()) delay(5);
    answer();
    count_files_folder[i_mp3]=ansbuf[5]*256+ansbuf[6];
    #ifdef _DEBUG
      Serial.print(i_mp3);
      Serial.print(":");
      Serial.println(count_files_folder[i_mp3]);
    #endif
// Вывод на екран количество файлов при запуске
    u8g.firstPage();
    do {
      draw_count_mp3();
    } while ( u8g.nextPage() );
//    delay(1000);
   }
}   

// Функция придания номера текущему состоянию
uint8_t choice_bird_rain()
{
/*
 *  8 вариантов 2*2*2
 *  до 12/после 12
 *  дверь в душевой открыта/закрытв
 *  Влажность высокая/нормальная
 */
  
  uint8_t rez=0;
  if (now.hour()>12)                rez=rez+1; 
  if (digitalRead(pin_Gerkon)==LOW) rez=rez+2;
  if (h>h_on)                       rez=rez+4;
  // Возможно еще условие           rez=rez+8;
  // Например было ли движение
  // Тогда будет 16 вариантов
  return rez;
}
